Scriptname CustomizableCamera extends SKI_ConfigBase
;Warning! Open this script with Notepad++ only! Indents may break otherwise!

function ApplyPreset() ;This function is used when selecting a preset
		SetSliderOptionValue(v_idle_S, v_idle, "{0}")
		SetSliderOptionValue(h_idle_S, h_idle, "{0}")
		SetSliderOptionValue(v_combat_S, v_combat, "{0}")
		SetSliderOptionValue(h_combat_S, h_combat, "{0}")
		SetSliderOptionValue(zoom_combat_S, zoom_combat, "{0}")
		Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
		
	    if (toggled_sneaking == true)
			Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
			Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
		else
			Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
			Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		endif
		
		if (toggle_view == true)
			Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
			Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
			Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
		endif
		
		toggle_view = false
		toggle_swap = false
		
		Game.UpdateThirdPerson()
endfunction

function ApplySettings() ;This function is used at Game Load
		presetslist = new string[5]
		presetslist[0] = " "
		presetslist[1] = "Default "
		presetslist[2] = "Center "
		presetslist[3] = "Center Above"
		presetslist[4] = "Over The Shoulder"

    Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
    Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
    Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
	
    if (toggled_sneaking == true)
		Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
	else
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
    endif
	
    Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
    Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
    Utility.SetINIFloat("fMouseWheelZoomSpeed:Camera", wheel_speed)
    Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
	
    if wheel_increments == 1.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 1.5)
	elseif wheel_increments == 2.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.604)
	elseif wheel_increments == 3.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.402)
	elseif wheel_increments == 4.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.202)
	elseif wheel_increments == 5.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.075)
	elseif wheel_increments == 6.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.0375)
	elseif wheel_increments == 7.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.01)
	endif
	
    Utility.SetINIFloat("fDefaultWorldFOV:Display", fov_slider)
    Utility.SetINIFloat("fDefault1stPersonFOV:Display", fov_slider)
    Utility.SetINIFloat("fShoulderDollySpeed:Camera", changestate_speed)
    Game.UpdateThirdPerson()
    UnregisterForKey(view_key)
    UnregisterForKey(swap_side)
    RegisterForKey(view_key)
    RegisterForKey(swap_side)
    toggle_view = false
    toggle_swap = false
	
	if (toggle_sneaking == true)
	sneak_button = Input.GetMappedKey("Sneak")
	UnregisterForKey(sneak_button)
    RegisterForKey(sneak_button)
	endIf
endfunction

; List
string[] presetslist

; OID
int v_idle_S
int h_idle_S
int v_combat_S
int h_combat_S
int zoom_combat_S
int vanity_max_S
int vanity_min_S
int wheel_speed_S
int wheel_increments_S
int pitch_zoom_S
int fov_slider_S
int changestate_speed_S
int view_distance_S
int view_height_S
int view_key_K
int swap_side_K
int toggle_sneaking_B
int sneak_height_S
int presets_M

; State
float v_idle = -10.0
float h_idle = 30.0
float v_combat = 20.0
float h_combat = 0.0
float zoom_combat = -100.0
float vanity_max = 600.0
float vanity_min = 155.0
float wheel_speed = 1.0
float wheel_increments = 5.0
float pitch_zoom = 100.0
float fov_slider = 65.0
float changestate_speed = 3.0
float view_distance = 90.0
float view_height = 0.0
int view_key = 34 ;G
int swap_side = 47;V
int sneak_button
bool toggle_view
bool toggle_swap
bool toggle_sneaking
bool toggled_sneaking
float sneak_height = 30.0
int presetsindex = 0

event OnPageReset(string page)
SetCursorFillMode(TOP_TO_BOTTOM)

SetCursorPosition(0)
AddHeaderOption("Camera")
    h_idle_S = AddSliderOption("Horizontal ", h_idle, "{0}")
    v_idle_S = AddSliderOption("Vertical ", v_idle, "{0}")
	presets_M = AddMenuOption("Presets ", presetslist[presetsindex])

SetCursorPosition(1)
AddHeaderOption("Camera In Combat")
    h_combat_S = AddSliderOption("Horizontal ", h_combat, "{0}")
    v_combat_S = AddSliderOption("Vertical ", v_combat, "{0}")
    zoom_combat_S = AddSliderOption("Zoom ", zoom_combat, "{0}")

SetCursorPosition(8)
AddHeaderOption("Miscellaneous")
    vanity_min_S = AddSliderOption("Minimum Distance", vanity_min, "{0}")
    vanity_max_S = AddSliderOption("Maximum Distance", vanity_max, "{0}")
    AddEmptyOption()
    wheel_speed_S = AddSliderOption("Zoom Speed", wheel_speed, "{0}")
    wheel_increments_S = AddSliderOption("Zoom Increments", wheel_increments, "{0}")
    changestate_speed_S = AddSliderOption("Camera Changing Speed", changestate_speed, "{0}")
    pitch_zoom_S = AddSliderOption("Pitch Down Zoom", pitch_zoom, "{0}")

SetCursorPosition(9)
AddHeaderOption("Features")
    fov_slider_S = AddSliderOption("Field Of View", fov_slider, "{0}")
	swap_side_K = AddKeyMapOption("Swap Side Key", swap_side)
	toggle_sneaking_B = AddToggleOption("Adaptive Sneaking", toggle_sneaking)
	sneak_height_S = AddSliderOption("Adaptive Sneaking Height", sneak_height, "{0}")
    view_key_K = AddKeyMapOption("View Mode Key", view_key)
    view_distance_S = AddSliderOption("View Mode Distance", view_distance, "{0}")
    view_height_S = AddSliderOption("View Mode Height", view_height, "{0}")
endEvent



event OnOptionSelect(int option)
	if (option == toggle_sneaking_B)
		toggle_sneaking = !toggle_sneaking
		SetToggleOptionValue(toggle_sneaking_B, toggle_sneaking)
		if (toggle_sneaking == true)
		    sneak_button = Input.GetMappedKey("Sneak")
			UnregisterForKey(sneak_button)
			RegisterForKey(sneak_button)
			RegisterForSingleUpdate(0.75)
			if (Game.GetPlayer().IsSneaking() == true)
			toggled_sneaking = true
				if (toggle_view == false)
				Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
				Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
				endif
			endif
		else
			toggled_sneaking = false
			if (toggle_view == false)
			Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
			Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
			endif
			UnregisterForKey(sneak_button)
		endif
		Game.UpdateThirdPerson()
	endIf
endEvent



event OnOptionMenuOpen(int option)
	if (option == presets_M)
		SetMenuDialogOptions(presetslist)
		SetMenuDialogStartIndex(presetsindex)
		SetMenuDialogDefaultIndex(0)
	endIf
endEvent
event OnOptionMenuAccept(int option, int index)
	if (option == presets_M)
		presetsindex = index
		SetMenuOptionValue(presets_M, presetslist[presetsindex])
		if (presetsindex == 1)
			v_idle = -10.0
			h_idle = 30.0
			v_combat = 20.0
			h_combat = 0.0
			zoom_combat = -100.0
			ApplyPreset()
			presetsindex = 0
		elseif (presetsindex == 2)
			v_idle = 0.0
			h_idle = 0.0
			v_combat = 0.0
			h_combat = 0.0
			zoom_combat = 0.0
			ApplyPreset()
			presetsindex = 0
		elseif (presetsindex == 3)
			v_idle = 25.0
			h_idle = 0.0
			v_combat = 25.0
			h_combat = 0.0
			zoom_combat = 0.0
			ApplyPreset()
			presetsindex = 0
		elseif (presetsindex == 4)
			v_idle = -10.0
			h_idle = 30.0
			v_combat = -10.0
			h_combat = 40.0
			zoom_combat = 0.0
			ApplyPreset()
			presetsindex = 0
		else
			presetsindex = 0
		endif
	endIf
endEvent



event OnOptionKeyMapChange(int option, int keyCode, string conflictControl, string conflictName)
	if (option == view_key_K)
      view_key = keyCode
      SetKeymapOptionValue(view_key_K, view_key)
      RegisterForKey(view_key)

	  elseif (option == swap_side_K)
      swap_side = keyCode
      SetKeymapOptionValue(swap_side_K, swap_side)
      RegisterForKey(swap_side)
  endIf
endEvent

event OnKeyDown(Int KeyCode)
if (!Utility.IsInMenuMode())
if KeyCode == view_key
toggle_view = !toggle_view
	if (toggle_view == true)
	Utility.SetINIFloat("fVanityModeMinDist:Camera", view_distance)
	Utility.SetINIFloat("fVanityModeMaxDist:Camera", view_distance)
	Utility.SetINIFloat("fOverShoulderPosZ:Camera", view_height)
	Utility.SetINIFloat("fOverShoulderPosX:Camera", 0.0)
	Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", view_height)
	Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", 0.0)
	Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", 0.0)
	Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", 0.0)
	else
	Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
	Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
	Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
	
		if (toggled_sneaking == true)
	    Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
		else
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		endif
	
		if (toggle_swap == true)
			if (h_combat < 0)
			Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", math.abs(h_combat))
			elseif (h_combat > 0)
			Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", 0.0 - h_combat)
			endif
			if (h_idle < 0)
			Utility.SetINIFloat("fOverShoulderPosX:Camera", math.abs(h_idle))
			elseif (h_combat > 0)
			Utility.SetINIFloat("fOverShoulderPosX:Camera", 0.0 - h_idle)
			endif
			else
			Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
			Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		endif
		
	Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
	endif
Game.UpdateThirdPerson()
endif


if (KeyCode == swap_side) && (toggle_view == false) && (swap_side != view_key)
toggle_swap = !toggle_swap
    if (toggle_swap == true)
		if (h_combat < 0)
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", math.abs(h_combat))
		elseif (h_combat > 0)
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", 0.0 - h_combat)
		endif
		if (h_idle < 0)
		Utility.SetINIFloat("fOverShoulderPosX:Camera", math.abs(h_idle))
		elseif (h_idle > 0)
		Utility.SetINIFloat("fOverShoulderPosX:Camera", 0.0 - h_idle)
		endif
    else
    Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
    Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
    endif
Game.UpdateThirdPerson()
endif

if (Keycode == sneak_button) && (toggle_sneaking == true) && (Game.GetPlayer().IsSwimming() == false)
	if (Game.GetPlayer().IsSneaking() == true)
		if (toggle_view == false)
		Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
		endif
	toggled_sneaking = true
	RegisterForSingleUpdate(0.75)
	else
		if (toggle_view == true)
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", view_height)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", view_height)
		else
		Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat)
		endif
	toggled_sneaking = false
	endif
Game.UpdateThirdPerson()
endif
endif
endevent



event OnUpdate() ;this is in case player manages to get out of sneaking without pressing the button, ex: mining

	if (toggled_sneaking == true) && (Game.GetPlayer().IsSneaking() == false)

		if (Game.GetPlayer().IsSwimming() == false)

			Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle)
			Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat)
			toggled_sneaking = false
			Game.UpdateThirdPerson()

		else

			RegisterForSingleUpdate(0.75)

		endif

	elseif (toggled_sneaking == true) && (Game.GetPlayer().IsSneaking() == true)

		RegisterForSingleUpdate(0.75)

	endif

endevent



event OnOptionSliderOpen(int option)
	if (option == v_idle_S)
		SetSliderDialogStartValue(v_idle)
		SetSliderDialogDefaultValue(-10.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

	elseIf (option == h_idle_S)
		SetSliderDialogStartValue(h_idle)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

	elseIf (option == v_combat_S)
		SetSliderDialogStartValue(v_combat)
		SetSliderDialogDefaultValue(20.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

	elseIf (option == h_combat_S)
		SetSliderDialogStartValue(h_combat)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == zoom_combat_S)
		SetSliderDialogStartValue(zoom_combat)
		SetSliderDialogDefaultValue(-100.0)
		SetSliderDialogRange(-500.0, 500.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == vanity_max_S)
		SetSliderDialogStartValue(vanity_max)
		SetSliderDialogDefaultValue(600.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == vanity_min_S)
		SetSliderDialogStartValue(vanity_min)
		SetSliderDialogDefaultValue(155.0)
		SetSliderDialogRange(0.0, 1000.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == wheel_speed_S)
		SetSliderDialogStartValue(wheel_speed)
		SetSliderDialogDefaultValue(1.0)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == wheel_increments_S)
		SetSliderDialogStartValue(wheel_increments)
		SetSliderDialogDefaultValue(5.0)
		SetSliderDialogRange(1.0, 7.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == pitch_zoom_S)
		SetSliderDialogStartValue(pitch_zoom)
		SetSliderDialogDefaultValue(100.0)
		SetSliderDialogRange(-500.0, 500.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == fov_slider_S)
		SetSliderDialogStartValue(fov_slider)
		SetSliderDialogDefaultValue(65.0)
		SetSliderDialogRange(10.0, 150.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == changestate_speed_S)
		SetSliderDialogStartValue(changestate_speed)
		SetSliderDialogDefaultValue(3.0)
		SetSliderDialogRange(1.0, 20.0)
		SetSliderDialogInterval(1.0)
		
  elseIf (option == view_distance_S)
		SetSliderDialogStartValue(view_distance)
		SetSliderDialogDefaultValue(90.0)
		SetSliderDialogRange(0.0, 100000.0)
		SetSliderDialogInterval(5.0)

  elseIf (option == view_height_S)
		SetSliderDialogStartValue(view_height)
		SetSliderDialogDefaultValue(0.0)
		SetSliderDialogRange(-100.0, 1000.0)
		SetSliderDialogInterval(1.0)

  elseIf (option == sneak_height_S)
		SetSliderDialogStartValue(sneak_height)
		SetSliderDialogDefaultValue(30.0)
		SetSliderDialogRange(-100.0, 100.0)
		SetSliderDialogInterval(1.0)

	endIf
endEvent

event OnOptionSliderAccept(int option, float value)
	if (option == v_idle_S)
		v_idle = value
		SetSliderOptionValue(v_idle_S, v_idle, "{0}")
		if (toggle_view == false) && (toggled_sneaking == false)
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", v_idle)
		elseif (toggled_sneaking == true) && (toggle_view == false)
		Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
		endif
		Game.UpdateThirdPerson()

	elseIf (option == h_idle_S)
		h_idle = value
		SetSliderOptionValue(h_idle_S, h_idle, "{0}")
		if (toggle_view == true)
		;wait for it to be toggled off
		elseif (toggle_swap == true)
        if (h_idle < 0)
          Utility.SetINIFloat("fOverShoulderPosX:Camera", math.abs(h_idle))
        elseif (h_idle > 0)
          Utility.SetINIFloat("fOverShoulderPosX:Camera", 0.0 - h_idle)
        endif
		else
		Utility.SetINIFloat("fOverShoulderPosX:Camera", h_idle)
		endif
		Game.UpdateThirdPerson()

	elseIf (option == v_combat_S)
		v_combat = value
		SetSliderOptionValue(v_combat_S, v_combat, "{0}")
		if (toggle_view == false) && (toggled_sneaking == false)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", v_combat)
		elseif (toggled_sneaking == true) && (toggle_view == false)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
		endif
		Game.UpdateThirdPerson()

	elseIf (option == h_combat_S)
		h_combat = value
		SetSliderOptionValue(h_combat_S, h_combat, "{0}")
		if (toggle_view == true)
		;wait for it to be toggled off
		elseif (toggle_swap == true)
		if (h_combat < 0)
        Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", math.abs(h_combat))
		elseif (h_combat > 0)
        Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", 0.0 - h_combat)
		endif
    else
		Utility.SetINIFloat("fOverShoulderCombatPosX:Camera", h_combat)
		endif
		Game.UpdateThirdPerson()

	elseIf (option == zoom_combat_S)
		zoom_combat = value
		SetSliderOptionValue(zoom_combat_S, zoom_combat, "{0}")
		if (toggle_view == false)
		Utility.SetINIFloat("fOverShoulderCombatAddY:Camera", zoom_combat)
		endif
		Game.UpdateThirdPerson()

	elseIf (option == vanity_max_S)
		vanity_max = value
		SetSliderOptionValue(vanity_max_S, vanity_max, "{0}")
		if (toggle_view == false)
		Utility.SetINIFloat("fVanityModeMaxDist:Camera", vanity_max)
		endif

	elseIf (option == vanity_min_S)
		vanity_min = value
		SetSliderOptionValue(vanity_min_S, vanity_min, "{0}")
		if (toggle_view == false)
		Utility.SetINIFloat("fVanityModeMinDist:Camera", vanity_min)
		endif

	elseIf (option == wheel_speed_S)
		wheel_speed = value
		SetSliderOptionValue(wheel_speed_S, wheel_speed, "{0}")
		Utility.SetINIFloat("fMouseWheelZoomSpeed:Camera", wheel_speed)

	elseIf (option == wheel_increments_S)
		wheel_increments = value
		SetSliderOptionValue(wheel_increments_S, wheel_increments, "{0}")
		if wheel_increments == 1.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 1.5)
		elseif wheel_increments == 2.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.604)
		elseif wheel_increments == 3.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.402)
		elseif wheel_increments == 4.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.202)
		elseif wheel_increments == 5.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.075)
		elseif wheel_increments == 6.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.0375)
		elseif wheel_increments == 7.0
        Utility.SetINIFloat("fMouseWheelZoomIncrement:Camera", 0.01)
		endif

	elseIf (option == pitch_zoom_S)
		pitch_zoom = value
		SetSliderOptionValue(pitch_zoom_S, pitch_zoom, "{0}")
		Utility.SetINIFloat("fPitchZoomOutMaxDist:Camera", pitch_zoom)
		
	elseIf (option == fov_slider_S)
		fov_slider = value
		SetSliderOptionValue(fov_slider_S, fov_slider, "{0}")
		Utility.SetINIFloat("fDefaultWorldFOV:Display", fov_slider)
		Utility.SetINIFloat("fDefault1stPersonFOV:Display", fov_slider)
    
	elseIf (option == changestate_speed_S)
		changestate_speed = value
		SetSliderOptionValue(changestate_speed_S, changestate_speed, "{0}")
		Utility.SetINIFloat("fShoulderDollySpeed:Camera", changestate_speed)

	elseIf (option == view_distance_S)
		view_distance = value
		SetSliderOptionValue(view_distance_S, view_distance, "{0}")
		if (toggle_view == true)
		Utility.SetINIFloat("fVanityModeMinDist:Camera", view_distance)
		Utility.SetINIFloat("fVanityModeMaxDist:Camera", view_distance)
		endif
		
	elseIf (option == view_height_S)
		 view_height = value
		SetSliderOptionValue(view_height_S,  view_height, "{0}")
		if (toggle_view == true)
		Utility.SetINIFloat("fOverShoulderPosZ:Camera", view_height)
		Utility.SetINIFloat("fOverShoulderCombatPosZ:Camera", view_height)
		Game.UpdateThirdPerson()
		endif
		
	elseIf (option == sneak_height_S)
		sneak_height = value
		SetSliderOptionValue(sneak_height_S, sneak_height, "{0}")
		if (toggled_sneaking == true) && (toggle_view == false)
		Utility.SetINIFloat("fOverShoulderPosz:Camera", v_idle + sneak_height)
		Utility.SetINIFloat("fOverShoulderCombatPosz:Camera", v_combat + sneak_height)
		Game.UpdateThirdPerson()
		endif
		
	endIf
endEvent



event OnOptionHighlight(int option)
	if (option == v_idle_S)
		SetInfoText("The vertical distance from character while NOT in combat.\nDefault: -10")
	elseIf (option == h_idle_S)
		SetInfoText("The horizontal distance from character while NOT in combat.\nDefault: 30")
	elseIf (option == v_combat_S)
		SetInfoText("The vertical distance from character while IN combat.\nDefault: 20")
	elseIf (option == h_combat_S)
		SetInfoText("The horizontal distance from character while IN combat.\nDefault: 0")
	elseIf (option == zoom_combat_S)
		SetInfoText("The distance from character while IN combat.\n Positive values means zooming in. \nDefault: -100")
	elseIf (option == vanity_max_S)
		SetInfoText("Maximum distance from character.\nDefault: 600")
	elseIf (option == vanity_min_S)
		SetInfoText("Minimum distance from character.\nDefault: 155")
	elseIf (option == wheel_speed_S)
		SetInfoText("The speed of zoom.\nDefault: 1")
	elseIf (option == wheel_increments_S)
		SetInfoText("Increments of zoom.\n Higher means more levels of zoom.\n Default: 5")
	elseIf (option == pitch_zoom_S)
		SetInfoText("Looking down zooms in or out.\n Positive values means zooming out. \n Default: 100")
	elseIf (option == fov_slider_S)
		SetInfoText("Adjusts your field of view. \n Default: 65 \n NOTE: FOV takes effect only after pressing Character Menu button. Default is TAB.")
	elseIf (option == changestate_speed_S)
		SetInfoText("Defines how fast changes the camera between states. \n Default: 3")
	elseIf (option == view_distance_S)
		SetInfoText("Defines the distance during View Mode. \n Default: 90")
	elseIf (option == view_height_S)
		SetInfoText("Defines the height during View Mode. \n Default: 0")
	elseIf (option == view_key_K)
		SetInfoText("Defines the button to press for View Mode.\n Default: G")
	elseIf (option == swap_side_K)
		SetInfoText("Temporarily swaps the camera horizontally.\n Default: V")
	elseIf (option == toggle_sneaking_B)
		SetInfoText("Raises the camera while sneaking.\n NOTE: If you change the sneak control OR swap from keyboard to controller, you need to re-activate this OR\n Save and Load to read your changed control.\n Default: Disabled")
	elseIf (option == sneak_height_S)
		SetInfoText("How much to raise the camera while sneaking.\n Requires Adaptive Sneaking to be ENABLED.\n Default: 30")
	elseIf (option == presets_M)
		SetInfoText("A selection of presets made by the author.\nWARNING: Selecting something automatically applies it. Use the blank space to cancel.\n You can suggest presets at the mod's page by leaving\n a comment.")
	endIf
endEvent



event OnConfigInit()
ApplySettings()
endevent
event OnGameReload()
parent.OnGameReload()
ApplySettings()
endevent